package ibase.webitm.ejb.adm;

import ibase.webitm.utility.*;
//import ibase.utility.CommonConstants;
import ibase.system.config.*;
//import java.text.*;
import java.util.*;
//import javax.xml.parsers.*;
import javax.ejb.*;
//import javax.naming.InitialContext;
import java.io.*;

import java.util.Calendar;
import java.util.Date;
import java.sql.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.rmi.RemoteException;
import org.w3c.dom.*;
import ibase.webitm.utility.ITMException;
import ibase.webitm.utility.GenericUtility;
import ibase.webitm.ejb.*;

import javax.ejb.Stateless; // added for ejb3


//public class SReturnPrsEJB extends ValidatorEJB implements SessionBean
@Stateless // added for ejb3
public class CopyGradeOtParamPrs extends ValidatorEJB implements CopyGradeOtParamPrsLocal, CopyGradeOtParamPrsRemote
{
	
	public String preSaveRec() throws RemoteException, ITMException
	{
		return "";
	}
	
	public String preSaveRec(String xmlString1, String domId, String objContext, String editFlag, String xtraParams, Connection conn) throws RemoteException, ITMException
	{
		System.out.println("@@@@@@@@********* CopyGradeOtParamPrs Called *******@@@@@@@@");
		Document dom = null;
		String errString = "";
		//ITMDBAccessEJB itmDBAccessLocal = new ITMDBAccessEJB();
		try
		{
			if (xmlString1 != null && xmlString1.trim().length() > 0)
			{
				dom = GenericUtility.getInstance().parseString(xmlString1);
				errString = executepreSaveRec(dom,domId,objContext,editFlag,xtraParams,conn);
				if (errString == null || errString.trim().length() == 0)
				{
					
					//errString = itmDBAccessLocal.getErrorString("","VTMCONF2","");
				}
				else
				{
					conn.rollback();
					//errString = itmDBAccessLocal.getErrorString("","VMPROCUSG","");
				}
			}
		}
		catch(Exception e)
		{
			System.out.println("Exception :CopyPayParamPrs :preSaveRec(): " + e.getMessage()+ ":");
			e.printStackTrace();
			throw new ITMException(e);
		}
		return errString;
	}
	private String executepreSaveRec(Document dom, String domID, String ObjContext, String editFlag, String xtraParams, Connection conn) throws RemoteException, ITMException
	{
		//Connection conn = null;
		PreparedStatement pstmt = null,pstmt1 = null,pstmtInser = null;
		ResultSet rs = null ,rs1 = null;
		String site_code = "",new_site_code="";
		String sql = "",sql1 = "",sqlInser;
		String chgUser = "",chgTerm = "",descr = "";
		String grade_code="";
		String limit_type="";
		
		double min_minutes=0.0;
		double limit_hrs=0.0;
	
		int cnt = 0,updCnt = 0;
		Date chgdate = null; 
		ITMDBAccessEJB itmDBAccessEJB = new ITMDBAccessEJB();
		GenericUtility genericUtility = GenericUtility.getInstance();		
		ITMDBAccessEJB itmDBAccessLocal = new ITMDBAccessEJB();
		String errString = "";
		boolean insertFlag=false;
		try
		{	
			ConnDriver connDriver = new ConnDriver();			
			conn = connDriver.getConnectDB("DriverITM");
			conn.setAutoCommit(false);
			site_code = genericUtility.getColumnValue("site_code",dom);
			//varName = genericUtility.getColumnValue("var_name",dom);
			new_site_code = genericUtility.getColumnValue("new_site_code",dom);
			String currAppdate ="";
			java.sql.Timestamp currDate = null;
			Object date = null;
			currDate =new java.sql.Timestamp(System.currentTimeMillis()) ;
			System.out.println(genericUtility.getDBDateFormat());
			SimpleDateFormat sdf = new SimpleDateFormat(genericUtility.getDBDateFormat());
			date = sdf.parse(currDate.toString());
			currDate =	java.sql.Timestamp.valueOf(sdf.format(date).toString() + " 00:00:00.0");
			currAppdate = new SimpleDateFormat(genericUtility.getApplDateFormat()).format(currDate).toString();
			
			chgUser = genericUtility.getValueFromXTRA_PARAMS(xtraParams,"chg_user");
			
			chgTerm = genericUtility.getValueFromXTRA_PARAMS(xtraParams,"chg_term");
		
			
			if( site_code == null || site_code.trim().length() ==0 )
			{
				//errString = itmDBAccessEJB.getErrorString("","PRDCODNULL","");
				//return errString;
			}
			else if( new_site_code == null || new_site_code.trim().length() == 0 )
			{
				errString = itmDBAccessEJB.getErrorString("","NEWSITENUL","");
				return errString;
			}
			else if( new_site_code != null && new_site_code.trim().length() > 0 )
			{
				if( new_site_code.trim().length() > 5 )
				{
					
					errString = itmDBAccessEJB.getErrorString("","NEWSITEINV","");
            		return errString;
					
				}
				else if(checkValidity(new_site_code, "site_code", "site", conn)<=0){
					insertFlag=true;
					errString = itmDBAccessEJB.getErrorString("","NEWSITNEXI","");
	        		return errString;
				}
				
			}
			
			
			if( site_code != null && site_code != null && new_site_code.trim().length() > 0 && site_code.trim().length() > 0 && insertFlag==false)
			{	
			//sql = " SELECT var_name,var_type,var_value,descr,var_subs FROM payrparm WHERE prd_code = ? ";   // and var_name = ?";
				
			sql =	"SELECT * FROM GRADE_SITE_OT WHERE SITE_CODE=?"; 
			pstmt =  conn.prepareStatement(sql);
			pstmt.setString(1,site_code);
			//pstmt.setString(2,varName);
			rs = pstmt.executeQuery();
			while(rs.next())
			{
				grade_code = rs.getString("grade_code");
				limit_hrs =rs.getDouble("limit_hrs");
				limit_type= rs.getString("limit_type");
				min_minutes =rs.getDouble("min_minutes");
				//sql1 = "SELECT count(*) FROM payrparm WHERE prd_code = ? and var_name = ? ";
				sql1 ="SELECT count(*) FROM GRADE_SITE_OT WHERE SITE_CODE = ? and GRADE_CODE=?";
				pstmt1 =  conn.prepareStatement(sql1);
				pstmt1.setString(1, new_site_code);
				pstmt1.setString(2, grade_code);
				rs1 = pstmt1.executeQuery();
				if(rs1.next())
				{
					cnt =  rs1.getInt(1);

				}
				rs1.close();
				rs1 = null;
				pstmt1.close();
				pstmt1 = null;
				System.out.println("@@@@@:::cnt:["+cnt+"]");
				if(cnt == 0)
				{
					sqlInser = "INSERT INTO GRADE_SITE_OT  ( grade_code, site_code, add_date, add_user, add_term, chg_date, chg_user, chg_term, limit_hrs, limit_type, min_minutes) "
						       +" VALUES (?,?,?, ?,?,?, ?,?,?, ?,?)  ";
					pstmtInser	= conn.prepareStatement(sqlInser);
					pstmtInser.setString(1,grade_code);
					pstmtInser.setString(2, new_site_code);
					pstmtInser.setTimestamp(3, currDate );
					pstmtInser.setString(4,chgUser);
					pstmtInser.setString(5,chgTerm);
					pstmtInser.setTimestamp(6, currDate );  ///currAppdate
					pstmtInser.setString(7,chgUser);
					pstmtInser.setString(8,chgTerm);
					pstmtInser.setDouble(9,limit_hrs);
					pstmtInser.setString(10,limit_type);
					pstmtInser.setDouble(11,min_minutes);
					updCnt = pstmtInser.executeUpdate();
					pstmtInser.close();
					pstmtInser=null;
					if(updCnt > 0 )
					{
						conn.commit();
						System.out.println("@@@@@ Record inserted for table no["+new_site_code +"]:::::::: @@@@@");
					}
				}
				else
				{
					//System.out.println("@@@@@ :::::Record already exist for PeriodCode["+newPeriodCode +"]::varName["+ varName +"]  :::::: @@@@@");
					//errString = itmDBAccessLocal.getErrorString("","VMDUPREC1","");
				}

			}
			if(rs != null)
			{
				rs.close();
				rs = null;
			}
			if(pstmt != null)
			{
				pstmt.close();
				pstmt = null;
			}
			}		
			//valueXmlString.append("</Root>\r\n");
		} // end of try 
		catch(Exception e)
		{
			try
			{
				conn.rollback();
			}
			catch(Exception ex)
			{
				throw new ITMException(ex);

			}
			throw new ITMException(e);

		}
		finally
		{
			try
			{
				conn.close();
				conn = null;
			}
			catch(Exception e)
			{
				throw new ITMException(e);
			}
		}
		return errString ;
	}
	
/*public String getDD_MM_YYYY_format(String str) throws Exception{
		
		  DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
		  Date date;
		  String dd_mm_yyyy="";
	
			date = (Date)formatter.parse(str);
			System.out.println("DDMMYYYY="+date);
			SimpleDateFormat format = new SimpleDateFormat("dd-MMM-yyyy");   
			dd_mm_yyyy=format.format(date);
			
	       //String orcleFormat= oracleFormatDate(dd_mm_yyyy); 
	       System.out.println("orcleFormat dd-mm-yyyy=="+dd_mm_yyyy);
	     return dd_mm_yyyy;
	}
	
public Timestamp getTimestamp(String str) throws Exception{
		
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss.S");
		java.util.Date date = sdf.parse(str);
		java.sql.Timestamp timestamp = new java.sql.Timestamp(date.getTime());
		//System.out.println("====="+timestamp);
		return timestamp;
		
	}
*/
	
	
	public int checkValidity(String retrival, String column_name, String table_name,  Connection from_site_conn) throws SQLException{
		boolean flag=false;
		PreparedStatement pstmt=null;
		ResultSet rs=null;
		String Query="";
		Connection conn=null;
		int count=0;
		Connection localConnection =null;
			
		try{
			       conn = from_site_conn;
			       Query="select count("+column_name+")  from "+table_name+" where "+column_name+"='"+retrival+"'";
			       System.out.println("====QUERY=="+Query);
			       pstmt=conn.prepareStatement(Query);
			       rs=pstmt.executeQuery(Query);
			       if(rs.next()){
			    	   count=rs.getInt(1);
			       	}
			      
		 }catch(Exception e){
			 e.printStackTrace();
		 }finally{
			 if(pstmt!=null){
				 pstmt.close();
				 pstmt=null;
			 }
			 if(rs!=null){
				 rs.close();
				 rs=null;
			 }
			 		}
		 System.out.println("count="+count);
		return count;
		}

}



